diff --git a/src/libdvdcss.c b/src/libdvdcss.c
index 2f78b78..2219096 100644
--- a/src/libdvdcss.c
+++ b/src/libdvdcss.c
@@ -274,6 +274,13 @@ static int set_cache_directory( dvdcss_t dvdcss )
         }
 #endif /* ! defined( _WIN32 ) */
     }
+    else {
+        int l = 0;
+        while ( *(psz_cache+l) )
+            l++;
+        if (l < PATH_MAX)
+          memcpy( dvdcss->psz_cachefile, psz_cache, l+1 );
+    }
 
     /* Check that there is enough space for the cache directory path and the
      * block filename. The +1s are path separators. */
